package prover;

import meerkat.protobuf.Crypto;

/**
 * Created by Tzlil on 12/30/2015.
 */
public class ProofOrganizer {

    private final OrProofInput first;
    private final OrProofInput second;
    private final OrProofInput third;
    private final OrProofInput fourth;

    protected ProofOrganizer(Crypto.RerandomizableEncryptedMessage e1,Crypto.RerandomizableEncryptedMessage e2
            ,Crypto.RerandomizableEncryptedMessage e1New,Crypto.RerandomizableEncryptedMessage e2New
            ,Crypto.EncryptionRandomness r1,Crypto.EncryptionRandomness r2,boolean switched) {
        if(!switched) {
            this.first = new OrProofInput(e1, e1New, e2, e1New, r1,TrueCouple.left);
            this.second = new OrProofInput(e1, e1New, e1, e2New,r1,TrueCouple.left);
            this.third = new OrProofInput(e2, e1New, e2, e2New,r2,TrueCouple.right);
            this.fourth = new OrProofInput(e1, e2New, e2, e2New,r2,TrueCouple.right);
        }else{
            this.first = new OrProofInput(e1, e1New, e2, e1New, r2,TrueCouple.right);
            this.second = new OrProofInput(e1, e1New, e1, e2New,r1,TrueCouple.right);
            this.third = new OrProofInput(e2, e1New, e2, e2New,r2,TrueCouple.left);
            this.fourth = new OrProofInput(e1, e2New, e2, e2New,r1,TrueCouple.left);
        }

    }

    public ProofOrganizer(Crypto.RerandomizableEncryptedMessage e1,Crypto.RerandomizableEncryptedMessage e2
            ,Crypto.RerandomizableEncryptedMessage e1New,Crypto.RerandomizableEncryptedMessage e2New) {
        this.first = new OrProofInput(e1, e1New, e2, e1New, null,TrueCouple.unknown);
        this.second = new OrProofInput(e1, e1New, e1, e2New,null,TrueCouple.unknown);
        this.third = new OrProofInput(e2, e1New, e2, e2New,null,TrueCouple.unknown);
        this.fourth = new OrProofInput(e1, e2New, e2, e2New,null,TrueCouple.unknown);
    }

    public enum OrProofOrder{
        first,second,third,fourth
    }

    public enum TrueCouple{
        left,right,unknown
    }


    public OrProofInput getOrProofInput(OrProofOrder orProofOrder){
        switch (orProofOrder){

            case first:
                return this.first;
            case second:
                return  this.second;
            case third:
                return this.third;
            case fourth:
                return this.fourth;
        }
        return null;
    }

    public class OrProofInput{


        public final Crypto.RerandomizableEncryptedMessage e1;
        public final Crypto.RerandomizableEncryptedMessage e1New;
        public final Crypto.RerandomizableEncryptedMessage e2;
        public final Crypto.RerandomizableEncryptedMessage e2New;
        protected final Crypto.EncryptionRandomness x;
        protected final TrueCouple flag;

        private OrProofInput(Crypto.RerandomizableEncryptedMessage e1, Crypto.RerandomizableEncryptedMessage e1New,
                            Crypto.RerandomizableEncryptedMessage e2, Crypto.RerandomizableEncryptedMessage e2New,
                            Crypto.EncryptionRandomness x, TrueCouple flag) {
            this.e1 = e1;
            this.e1New = e1New;
            this.e2 = e2;
            this.e2New = e2New;
            this.x = x;
            this.flag = flag;
        }
    }
}
